

;	extern "C" bool copytest_a(void *dst, void *src, size_t cnt)
;	returns false if dst, src or cnt are not 32-byte aligned

GLOBAL _copytest_a
GLOBAL _copytest_a_getinfo
GLOBAL _rdtsc

%define BLOCKSIZE		4096
%define PARANOID		1


[segment .data]


copytest_a_name:
	db "P-III SIMD copytest"
%if PARANOID
	db " (paranoid)"
%endif
	db 0



[segment .text]

%define	CHUNKSIZE		DWORD BLOCKSIZE
%define	NEGCHUNKSIZE	DWORD -BLOCKSIZE


_copytest_a_getinfo:
	mov ecx, [esp+4]
	lea eax, [copytest_a_name]
	mov [ecx], eax
	mov ecx, [esp+8]
	mov eax, CHUNKSIZE
	mov [ecx], eax
	ret


_copytest_a:
%if PARANOID
	mov eax, [esp+12]
	or eax, [esp+8]
	or eax, [esp+4]
	and eax, DWORD 31
	cmp eax, 0
	jz all_ok

	xor eax, eax
	ret
%endif

all_ok:
	push esi
	push edi
	push ebx
	mov ebx, [esp+12+12]
	mov esi, [esp+8+12]
	mov edi, [esp+4+12]

	; do 8k at a time
another_8k:
	cmp ebx, DWORD CHUNKSIZE
	jng last_loop

	; warm the cache (read)
	mov ecx, esi
	add ecx, DWORD CHUNKSIZE
	mov edx, DWORD NEGCHUNKSIZE
	xor eax, eax

even_warmer:
	mov al, [ecx+edx]
	add edx, 32
	jl even_warmer

	; perform the copy
	mov edx, DWORD CHUNKSIZE
	sub ebx, DWORD CHUNKSIZE

copy_another2:
	movaps xmm0, [esi]
	movaps xmm1, [esi+16]
	add esi, 32
	movntps [edi], xmm0
	movntps [edi+16], xmm1
	add edi, 32
	sub edx, 32
	jg copy_another2

	jmp another_8k

last_loop:
	cmp ebx, 0
	jz done

	; warm the cache
	xor edx, edx
	mov ecx, esi
	sub edx, ebx
	add ecx, ebx
	xor eax, eax

even_warmer_l:
	mov al, [ecx+edx]
	add edx, 32
	jl even_warmer_l

copy_another2_l:
	movaps xmm0, [esi]
	movaps xmm1, [esi+16]
	add esi, 32
	movntps [edi], xmm0			; perhaps these should be streaming stores?
	movntps [edi+16], xmm1
	add edi, 32
	sub ebx, 32
	jg copy_another2_l
	
done:
	pop ebx
	pop edi
	pop esi
	mov eax, 1
	ret



_rdtsc:
	rdtsc
	ret
